#!/usr/bin/php
<?php

set_time_limit(0);

require 'config.php';

require_once 'inc/shell_colors.php';
$colors = new Colors();

require_once YOUR_WP_DIR . '/wp-load.php';

$posts = $wpdb->get_results("SELECT $wpdb->posts.* FROM $wpdb->posts WHERE $wpdb->posts.post_status = 'publish' AND ($wpdb->posts.post_type = 'post' OR $wpdb->posts.post_type = 'page')");

foreach($posts as $post) {
    
    preg_match_all('#<img.*src="(?<src>[^"]+)"#Um', $post->post_content, $images);
    
    if (!$num_images = count($images['src'])) {
        continue;
    }
    
    $my_post = array();
    $my_post['ID'] = $post->ID;
    $my_post['post_content'] = $post->post_content;
    
    $post_slug = sanitize_title($post->post_title);
    
    for($i = 0; $i < $num_images; $i++) {
        $src = $images['src'][$i];
        
        if(strpos($src, 'SQUARESPACE_CACHEVERSION') === FALSE) {
            continue;
        }
        
        if(strpos($src, SQUARESPACE_URL) !== 0)
            $src = SQUARESPACE_URL . $src;
        
        // hash the filename in case the original image link is too long
        $filename = md5(array_pop(explode('/', $src)));
        
        // Download the file
        
        $cmd = sprintf('wget --quiet "%s" -O "%s";', $src, YOUR_DOWNLOAD_PATH . DIRECTORY_SEPARATOR . $filename);
        shell_exec($cmd);
        
        $ext = array_pop(explode('/' , mime_content_type(YOUR_DOWNLOAD_PATH . DIRECTORY_SEPARATOR . $filename)));
        if ($ext == 'jpeg') $ext = 'jpg';
        
        $new_filename = SQUARESPACE_PREFIX . $post_slug;
        if ($i > 0) {
            $new_filename .= '-' . $i;
        }
        $new_filename .= '.' . $ext;
        
        // Rename squarespace crap - new format post_slug-number.extension
        // e.g 2.jpg?__SQUARESPACE_CACHEVERSION=1327687105463 is renamed to adorable-miniature-and-tea-cup-poodles-5.jpg
        
        rename(
            YOUR_DOWNLOAD_PATH . DIRECTORY_SEPARATOR . $filename,
            YOUR_DOWNLOAD_PATH . DIRECTORY_SEPARATOR . $new_filename
        );
        
        // update wordpress html to point to new filename
        // we'll put the full URL in with another script once they are batch imported
        // We'll use this to reference the correct attachment ID
        
        $my_post['post_content'] = str_replace($src, $new_filename, $my_post['post_content']);
        
        echo $post->ID . ' ' . $colors->getColoredString($filename, 'light_red') . ' > ' . $colors->getColoredString($new_filename, 'light_blue') .  ' ' . $colors->getColoredString('COMPLETE', 'green') . "\n";
    }
    
    // Update the post into the database
    wp_update_post($my_post);
}
